% definition of Tukey window function: size and parameter alpha
winFun = tukeywin(90,0.25);
% apply window function pixelwise on each column of the input picture
winImg = repmat(winFun,1,90);

% get direction of path where all input pictures are stored. Please specify
% your path here!
path = uigetdir('C:\Users....');

content = dir(path);

foldernames = {};

for idx = 1:numel(content)
    name = content(idx).name;
    foldernames{end+1} = name;
end

foldernames = foldernames(3:end);

collection = cell(1,2);

counter = 1;
cellCount = 1;


% searching all images in all folders in image root path given above
for idx = 1:numel(foldernames)
    foldername = foldernames{idx};
    currPath = strcat(path,'\',foldername);
    cd(currPath);
    categories = dir(currPath);    
    categories = {categories.name};
    categories = categories(3:end);
    
    for jdx = 1:numel(categories)    
        finalPath = strcat(currPath,'\',categories{jdx});
        cd(finalPath)
        disp(finalPath)
        
        finalContent = dir(finalPath);
        finalContent = {finalContent.name};
        finalContent = finalContent(3:end);
        
        % for all pictures, we apply the Tukey window function, then
        % imadjust (contrast enhancement) and finally we feed the image in
        % the neural network by predict(.)
        for kdx = 1:numel(finalContent)
            finalFile = finalContent{kdx};
            img = imread(finalFile);
            img = im2double(img);
            img = img.*winImg;
            img = imadjust(img);
            img = im2uint8(img);
            
            NNans = predict(net,img);
            collection{counter,1} = NNans;
            collection{counter,2} = img;
            counter = counter + 1;
            cellCount = cellCount +1;
        end
        
    end
end

collection = sortrows(collection,1);
disp('sorted')

collectionVals = [];
for idx = 1:size(collection)
    row = collection(idx,1);
    val = row{:};
    collectionVals(end+1) = val;
end

% store all images in the given folder! 
targetSortFolder = 'C:\Users\...';


% display all output values from the CNN
figure
[N,c] = hist(collectionVals,100);

% fit the resulting histogram by four Gaussians: one for each ditinct class
% and one accounting for the background signal
options = fitoptions('gauss4', 'Lower', [-Inf,-300,-Inf,-Inf,-50,-Inf,-Inf,0,-Inf,-Inf,0,-Inf],'Upper',[Inf,0,Inf,Inf,50,Inf,Inf,300,Inf,Inf,127,Inf]);
FitFun = fit(c',N','gauss4',options);

plot(c,N)
hold on


Sl = FitFun.b1;
dSl = FitFun.c1/sqrt(2);
Sll = Sl-dSl;
Slu = Sl+dSl;

Cr = FitFun.b4;
dCr = FitFun.c4/sqrt(2);
Crl = Cr-dCr;
Cru = Cr+dCr;

[val1,lBC] = min(abs(c-Crl));
[val2,uBC] = min(abs(c-Cru));
[val3,lBS] = min(abs(c-Sll));
[val4,uBS] = min(abs(c-Slu));


plot(FitFun)







